/*
 * abmisc.h - abmail miscellaneous routines
 *
 * Copyright (C) 2006-2008 Taiji Yamada <taiji@aihara.co.jp>
 *
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Affero General Public License for more details.
 */
#ifndef _abmisc_h_
#define _abmisc_h_

extern struct am default_ams_clients[];

extern struct am builtin_ams[];

struct amset {
  size_t nam; struct am *ams, *builtin_ams;
};

extern struct amset amset_clients, amset;

struct am *am_bsearch(int n, struct am ams[], struct in_addr a);
struct am *am_lsearch(int n, struct am ams[], struct in_addr a);
struct am *am_search(int n, struct am ams[], struct in_addr a);

void am_set_spaces(size_t nam, struct am ams[]);

void am_check(size_t nam, struct am ams[]);

void am_sorts(size_t nam, struct am ams[], int check);

struct am *am_duplicates(size_t nam, struct am ams[]);

void amset_append(struct amset *as, struct am am);

void amset_free(struct amset *as);

void amset_fappend(struct amset *as, FILE *fp, int rc, int info);

#if !defined(DISABLE_IPv6)
extern struct am6 default_am6s_clients[];

extern struct am6 builtin_am6s[];

struct am6set {
  size_t nam; struct am6 *ams, *builtin_ams;
};

extern struct am6set am6set_clients, am6set;

struct am6 *am6_bsearch(int n, struct am6 ams[], struct in6_addr a);
struct am6 *am6_lsearch(int n, struct am6 ams[], struct in6_addr a);
struct am6 *am6_search(int n, struct am6 ams[], struct in6_addr a);

void am6_set_spaces(size_t nam, struct am6 ams[]);

void am6_check(size_t nam, struct am6 ams[]);

void am6_sorts(size_t nam, struct am6 ams[], int check);

struct am6 *am6_duplicates(size_t nam, struct am6 ams[]);

void am6set_append(struct am6set *as, struct am6 am);

void am6set_free(struct am6set *as);

void am6set_fappend(struct am6set *as, FILE *fp, int rc, int info);
#endif

void amset_read(struct amset *as,
#if !defined(DISABLE_IPv6)
		struct am6set *a6s,
#endif
		int info, int check, int argc, char *argv[]);

void amset_clients_read(struct amset *as,
#if !defined(DISABLE_IPv6)
			struct am6set *a6s,
#endif
			int info, int check, int argc, char *argv[]);

#endif
