backup_lst_out(){
  for out in *.lst.out; do cp -p "$out" "$out$1"; done
}
diffs_lst_out(){
  for out in *.lst.out; do echo diff "$out$1" "$out$2"; diff "$out$1" "$out$2"; done
}
db_start(){
  if [ "$sudo" != "" ]; then
    echo "starting abaddr server"
    $sudo ./abaddrd -C -R -W &
    sleep 5
  else
    $abaddrc -C -R -W
  fi
}
db_stop(){
  if [ "$sudo" != "" ]; then
    if [ "`uname -s`" = SunOS ]; then
      $sudo pkill abaddrd
    else
      $sudo killall abaddrd
    fi
    echo "stopping abaddr server"
  else
    :
  fi
}
do_test(){
db_start
cp /dev/null test.log
backup_lst_out 00
echo '# 01' >> test.log
$abaddrc -c "example.com" -s -rc  1 -lt -1 203.82.0.0/16 -W
$abaddrc -g 203.82.141.96/28 >> test.log
backup_lst_out 01
diffs_lst_out 00 01 >> test.log
echo '# 02' >> test.log
$abaddrc -c "example.com" -s -rc -1 -lt  0 203.82.1.0/24 -rc  1 -lt  0 203.82.128.0/28 -rc 0 -lt  0 203.82.130.1/32 -rc  1 -lt  0 203.82.254.0/24 -W
$abaddrc -g 203.82.1.127 203.82.128.0/28 203.82.130.1 203.82.254.128 >> test.log
backup_lst_out 02
diffs_lst_out 00 02 >> test.log
echo '# 03' >> test.log
$abaddrc -c "example.com" -s -rc -1 -lt  0 203.82.1.128-203.82.254.127 -W
$abaddrc -g 203.82.1.127 203.82.128.0/28 203.82.130.1 203.82.254.128 >> test.log
backup_lst_out 03
diffs_lst_out 00 03 >> test.log
echo '# 04' >> test.log
$abaddrc -c "example.com" -s -rc  1 -lt -1 203.82.0.0/16 -W
$abaddrc -c "example.com" -s -rc -1 -lt  0 203.82.1.0/24 -rc  1 -lt  0 203.82.128.0/28 -rc 0 -lt  0 203.82.130.1/32 -rc  1 -lt  0 203.82.254.0/24 -W
$abaddrc -c "example.com" -s -rc -1 -lt -1 203.82.1.128-203.82.254.127 -W
$abaddrc -g 203.82.1.127 203.82.128.0/28 203.82.130.1 203.82.254.128 >> test.log
backup_lst_out 04
diffs_lst_out 00 04 >> test.log
echo '# 05' >> test.log
$abaddrc -c "example.com" -s -rc  1 -lt -1 203.82.0.0/16 -W
$abaddrc -c "example.com" -s -rc -1 -lt  0 203.82.1.0/24 -rc  1 -lt  0 203.82.128.0/28 -rc 0 -lt  0 203.82.130.1/32 -rc  1 -lt  0 203.82.254.0/24 -W
$abaddrc -c "example.com" -s -rc -1 -lt -2 203.82.1.128-203.82.254.127 -W
$abaddrc -g 203.82.1.127 203.82.128.0/28 203.82.130.1 203.82.254.128 >> test.log
backup_lst_out 05
diffs_lst_out 00 05 >> test.log
db_stop
}

if [ "`uname -s`" = SunOS ]; then
  SUDO=env
fi

[ ! -d result/regression ] && mkdir result/regression

sudo=${SUDO:-sudo}
abaddrc="./abaddrc -S localhost"
do_test
[ -d result/regression/test-rpc ] && rm -rf result/regression/test-rpc
mkdir result/regression/test-rpc
mv -f abaddr.bdb *.lst.out* test.log result/regression/test-rpc

sudo=${SUDO:-sudo}
[ "`uname -s`" = SunOS ] && sudo=
abaddrc="${SUDO:-sudo} ./abaddrc"
do_test
[ -d result/regression/test-bdb ] && rm -rf result/regression/test-bdb
mkdir result/regression/test-bdb
mv -f abaddr.bdb *.lst.out* test.log result/regression/test-bdb

sudo=
abaddrc=./abaddrc
do_test
[ -d result/regression/test-one ] && rm -rf result/regression/test-one
mkdir result/regression/test-one
mv -f abaddr.bdb *.lst.out* test.log result/regression/test-one

diff -r --exclude='*.out*' --exclude='*.bdb' result/reference result/regression
